# This file was generated by mettle.genes.braze.GenPy3 [ver 2.1] on Mon Jan 24 11:35:04 2022
#

import datetime
import uuid
import mettle.braze
import mettle.lib

from mettle.io.iserializable import ISerializable

class bUserLogin(ISerializable):

    def __init__(self,
                 site_code: str = '',
                 user_id: str = '',
                 auth_type: str = '',
                 auth_data: str = '',
                 ip_addr: str = '',
                 geo_loc: str = ''):
        """
        Constructor.

        :param site_code:
        :param user_id:
        :param auth_type:
        :param auth_data:
        :param ip_addr:
        :param geo_loc:
        """
        self.site_code = site_code
        self.user_id = user_id
        self.auth_type = auth_type
        self.auth_data = auth_data
        self.ip_addr = ip_addr
        self.geo_loc = geo_loc

    def clear(self):
        self.site_code = ''
        self.user_id = ''
        self.auth_type = ''
        self.auth_data = ''
        self.ip_addr = ''
        self.geo_loc = ''

    def _name(self) -> str:
        """
        Get the struct name.

        :return: Name of the struct
        """
        return 'bUserLogin'

    def _serialize(self, _w: mettle.io.IWriter, _oname: str = None):
        """
        Serialize this struct.

        :param _w:
        :param _oname:
        """
        if not _oname:
            _oname = self._name()

        _w.write_start(_oname)
        _w.write_string("siteCode", self.site_code)
        _w.write_string("userId", self.user_id)
        _w.write_char("authType", self.auth_type)
        _w.write_string("authData", self.auth_data)
        _w.write_string("ipAddr", self.ip_addr)
        _w.write_string("geoLoc", self.geo_loc)
        _w.write_end(_oname)

    def _deserialize(self, _r: mettle.io.IReader, _oname: str = None) -> int:
        """
        Deserialize this struct.

        :param _r:
        :param _oname:
        """
        if _oname == None:
            _oname = self._name()

        _r.read_start(_oname)
        self.site_code = _r.read_string("siteCode")
        self.user_id = _r.read_string("userId")
        self.auth_type = _r.read_char("authType")
        self.auth_data = _r.read_string("authData")
        self.ip_addr = _r.read_string("ipAddr")
        self.geo_loc = _r.read_string("geoLoc")
        _r.read_end(_oname)

    @staticmethod
    def _cache_davs(dvc: mettle.lib.DavCache = None):
        """
        Cache the DAV into the dav cache (or create one) and return it.

        :param dvc: Target cache, if None a new one is created and returned.
        """
        if not dvc:
            dvc = mettle.lib.DavCache()

        dvc.add_targ("site_code", mettle.lib.Dav(mettle.lib.Dav.eDavType.Max, 32))
        dvc.add_targ("site_code", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("user_id", mettle.lib.Dav(mettle.lib.Dav.eDavType.Max, 128))
        dvc.add_targ("user_id", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("auth_type", mettle.lib.Dav(mettle.lib.Dav.eDavType.In, ['P','S','T']))
        dvc.add_targ("auth_data", mettle.lib.Dav(mettle.lib.Dav.eDavType.Max, 256))
        dvc.add_targ("auth_data", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))

        return dvc

    def _get_davs(self, dvc=None):
        return self._cache_davs(dvc)

    def __repr__(self) -> str:
        return '<bUserLogin [site_code:%.32s, user_id:%.32s, auth_type:%.32s, auth_data:%.32s, ip_addr:%.32s, geo_loc:%.32s]>' % (
            self.site_code, self.user_id, self.auth_type, self.auth_data, self.ip_addr, self.geo_loc)

    # List class
    class List(list, ISerializable):

        def _name(self) -> str:
            """
            Get list name
            """
            return 'bUserLogin.List'

        def _serialize(self, _w: mettle.io.IWriter, _oname: str = None):
            """
            Serialize the list

            :param _w:
            :param _oname:
            """
            if _oname == None:
                _oname = self._name()

            _w.write_start_list(_oname, len(self))

            for _rec in self:
                _rec._serialize(_w)

            _w.write_end(_oname)

        def _deserialize(self, _r: mettle.io.IReader, _oname: str = None) -> int:
            """
            Deserialize the list

            :param _r:
            :param _oname:
            """
            if _oname == None:
                  _oname = self._name()

            _cnt = _r.read_start_list(_oname)

            while _cnt >= 1:
                _rec  = bUserLogin()
                _cnt -= 1
                _rec._deserialize(_r)
                self.append(_rec)

            _r.read_end(_oname)

        def _get_davs(self, dvc: mettle.lib.DavCache = None) -> int:
            """
            Cache the davs

            :param dvc:
            """
            return bUserLogin._cache_davs(dvc)

        def __repr__(self) -> str:
            return '<bUserLogin.List[%d]>' % (len(self))

