# This file was generated by mettle.genes.db.GenPy3 [ver 2.1] on Mon Jan 24 11:35:04 2022
#  Target Database = postgresql
#
import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_fura.db.tables.itoken_sentry_expired import iTokenSentryExpired
from bs_fura.db.tables.token_sentry import tTokenSentry

class dTokenSentryExpired:

    def __init__(self, dbcon: mettle.db.IAConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self._dbcon   = dbcon
        self._dbstmnt = None
        self.irec     = iTokenSentryExpired()
        self.orec     = tTokenSentry()

    def __del__(self):
        """
        Destructor.
        """
        del self._dbstmnt

    def __enter__(self):
        """
        With statement enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        With statement exit.
        """
        self._destroy()

    def _destroy(self):
        if self._dbstmnt == None:
            return

        del self._dbstmnt
        self._dbstmnt = None

    async def exec_deft(self,
                        last_poll: datetime.datetime) -> "dTokenSentryExpired":
        """
        Execute the query by setting all the inputs.

        :param last_poll: datetime.datetime
        :return: Self for convenience.
        """
        self.irec.last_poll = last_poll

        return await self.exec()

    async def exec(self, irec: iTokenSentryExpired = None) -> "dTokenSentryExpired":
        """
        Execute the query, optionally passing in the input rec.

        :param irec:
        :return: Self for convenience.
        """
        if irec:
            self.irec._copy_from(irec)

        self._destroy()

        self._dbstmnt = await self._dbcon.statement("TokenSentryExpired", self._dbcon.STMNT_TYPE_READ)

        self._dbstmnt.sql("""select
  t.*
from
  fura.tokensentry t
where
  t.lastpoll <= :lastPoll""")

        self._dbstmnt.bind_in("lastPoll", self.irec.last_poll, datetime.datetime)

        self._dbstmnt.bind_out("site_id", int, 4)
        self._dbstmnt.bind_out("token_cnt", int, 8)
        self._dbstmnt.bind_out("last_poll", datetime.datetime)

        await self._dbcon.execute(self._dbstmnt)

        if irec:
            irec._copy_from(self.irec)

        return self

    async def fetch(self) -> bool:
        """
        Fetches the next row from the executed query.

        :return: True if a row is retreived.
        """
        if not await self._dbcon.fetch(self._dbstmnt):
            return False

        self.orec.site_id = self._dbstmnt.result[0]
        self.orec.token_cnt = self._dbstmnt.result[1]
        self.orec.last_poll = self._dbstmnt.result[2]

        return True

    async def fetch_all(self, outList: tTokenSentry.List, clearList: bool = True) -> int:
        """
        Fetch all the rows into the specified list and return the list count.

        :param outList:
        :param clearList:
        :return: Number of rows fetched.
        """
        if clearList:
            outList.clear()

        while await self.fetch():
            outList.append(copy.deepcopy(self.orec))

        return len(outList)

