# This file was generated by mettle.genes.db.GenPy3 [ver 2.1] on Mon Jan 24 11:35:04 2022
#  Target Database = postgresql
#
import asyncio
import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_fura.db.tables.ula import tUla

from .ula_insert import dUlaInsert

class dUla:

    def __init__(self, dbcon: mettle.db.IAConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self.rec    = tUla()
        self._dbcon = dbcon

    def __enter__(self):
        """
        DAO enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        DAO exit.
        """
        pass

    async def insert_deft(self,
                          site_id: int,
                          site_code: str,
                          tm_stamp: datetime.datetime,
                          usr_id: str,
                          err_code: int,
                          state: str,
                          action: str,
                          auth_type: str,
                          auth_ip: str,
                          auth_geo: str):
        """
        Insert the record setting all column values.

        :param site_id: int
        :param site_code: str
        :param tm_stamp: datetime.datetime
        :param usr_id: str
        :param err_code: int
        :param state: str
        :param action: str
        :param auth_type: str
        :param auth_ip: str
        :param auth_geo: str
        """
        self.rec.site_id = site_id
        self.rec.site_code = site_code
        self.rec.tm_stamp = tm_stamp
        self.rec.usr_id = usr_id
        self.rec.err_code = err_code
        self.rec.state = state
        self.rec.action = action
        self.rec.auth_type = auth_type
        self.rec.auth_ip = auth_ip
        self.rec.auth_geo = auth_geo

        await self.insert()

    async def insert(self, irec: tUla = None):
        """
        Insert the record in the database with the record or irec if it is not None.

        :param irec: If not None use this record to insert into the database.
        """
        if irec:
            self.rec._copy_from(irec)

        with dUlaInsert(self._dbcon) as _qry:
            await _qry.exec(self.rec)

        if irec:
            irec._copy_from(self.rec)

