# This file was generated by mettle.genes.db.GenPy3 [ver 2.1] on Mon Jan 24 11:35:04 2022
#

import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

class iUlaSearch(mettle.io.ISerializable):

    def __init__(self,
                 site_id: int = 0,
                 date_from: datetime.datetime = None,
                 date_to: datetime.datetime = None,
                 criteria: str = ''):
        """
        Constructor.

        :param site_id: int
        :param date_from: datetime.datetime
        :param date_to: datetime.datetime
        :param criteria: str
        """
        self.site_id = site_id
        self.date_from = date_from
        self.date_to = date_to
        self.criteria = criteria

    def clear(self):
        """
        Clears all member variables for this database record.
        """
        self.site_id = 0
        self.date_from = None
        self.date_to = None
        self.criteria = ''

    def _name(self) -> str:
        """
        Name of the record.

        :return: The name.
        """
        return 'iUlaSearch'

    def _serialize(self, _w: mettle.io.IWriter, _oname: str = None):
        """
        Serialize record to a stream.

        :param _w:
        :param _oname:
        """
        if _oname == None:
            _oname = self._name()

        _w.write_start(_oname)
        _w.write_int32("site_id", self.site_id)
        _w.write_datetime("date_from", self.date_from)
        _w.write_datetime("date_to", self.date_to)
        _w.write_string("criteria", self.criteria)
        _w.write_end(_oname)

    def _deserialize(self, _r: mettle.io.IReader, _oname: str = None):
        """
        Deserialize record from a stream.

        :param _r:
        :param _oname:
        """
        if _oname == None:
            _oname = self._name()

        _r.read_start(_oname)
        self.site_id = _r.read_int32("site_id")
        self.date_from = _r.read_datetime("date_from")
        self.date_to = _r.read_datetime("date_to")
        self.criteria = _r.read_string("criteria")
        _r.read_end(_oname)

    def _copy_from(self, rec: "iUlaSearch"):
        """
        Copies the column from the rec into this record.

        :param rec: The source record.
        """
        self.site_id = rec.site_id
        self.date_from = rec.date_from
        self.date_to = rec.date_to
        self.criteria = rec.criteria

    @staticmethod
    def _cache_davs(dvc=None):
        """
        Cache the DAV into the dav cache (or create one) and return it.

        :param dvc: (mettle.lib.DavCache), target cache, if None a new one is created and returned.
        """
        if dvc is None:
            dvc = mettle.lib.DavCache()

        dvc.add_targ("siteId", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("dateFrom", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("dateTo", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("criteria", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))

        return dvc

    def _get_davs(self, dvc=None):
        iUlaSearch._cache_davs(dvc)

    def __repr__(self) -> str:
        return '<Ula [site_id:%r, date_from:%s, date_to:%s, criteria:%.32s]>' % (
            self.site_id, self.date_from, self.date_to, self.criteria)


    class List(list, mettle.io.ISerializable):
        """
        List Class
        """

        def _name(self) -> str:
            """
            Name of the list.

            :return: The name
            """
            return 'iUlaSearch.List'

        def _serialize(self, _w: mettle.io.IWriter, _oname: str = None):
            """
            Serialize the list to a stream.

            :param _w:
            :param _oname:
            """
            if _oname == None:
                _oname = self._name()

            _w.write_start_list(_oname, len(self))

            for _rec in self:
                _rec._serialize(_w)

            _w.write_end(_oname)

        def _deserialize(self, _r: mettle.io.IReader, _oname: str = None):
            """
            Deserialize the list from a stream.

            :param _r:
            :param _oname:
            """
            if _oname == None:
                _oname = self._name()

            _cnt = _r.read_start_list(_oname)

            while _cnt >= 1:
                _rec  = iUlaSearch()
                _cnt -= 1
                _rec._deserialize(_r)
                self.append(_rec)

            _r.read_end(_oname)

        def __repr__(self) -> str:
            return '<iUlaSearch.List[%d]>' % (len(self))

        def _get_davs(self, dvc=None):
            return iUlaSearch._cache_davs(dvc)

