# This file was generated by mettle.genes.db.GenPy3 [ver 2.1] on Mon Jan 24 11:35:04 2022
#

import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

class iUsrAuthByToken(mettle.io.ISerializable):

    def __init__(self,
                 site_code: str = '',
                 auth_type: str = '',
                 auth_data: str = ''):
        """
        Constructor.

        :param site_code: str
        :param auth_type: str
        :param auth_data: str
        """
        self.site_code = site_code
        self.auth_type = auth_type
        self.auth_data = auth_data

    def clear(self):
        """
        Clears all member variables for this database record.
        """
        self.site_code = ''
        self.auth_type = ''
        self.auth_data = ''

    def _name(self) -> str:
        """
        Name of the record.

        :return: The name.
        """
        return 'iUsrAuthByToken'

    def _serialize(self, _w: mettle.io.IWriter, _oname: str = None):
        """
        Serialize record to a stream.

        :param _w:
        :param _oname:
        """
        if _oname == None:
            _oname = self._name()

        _w.write_start(_oname)
        _w.write_string("site_code", self.site_code)
        _w.write_char("auth_type", self.auth_type)
        _w.write_string("auth_data", self.auth_data)
        _w.write_end(_oname)

    def _deserialize(self, _r: mettle.io.IReader, _oname: str = None):
        """
        Deserialize record from a stream.

        :param _r:
        :param _oname:
        """
        if _oname == None:
            _oname = self._name()

        _r.read_start(_oname)
        self.site_code = _r.read_string("site_code")
        self.auth_type = _r.read_char("auth_type")
        self.auth_data = _r.read_string("auth_data")
        _r.read_end(_oname)

    def _copy_from(self, rec: "iUsrAuthByToken"):
        """
        Copies the column from the rec into this record.

        :param rec: The source record.
        """
        self.site_code = rec.site_code
        self.auth_type = rec.auth_type
        self.auth_data = rec.auth_data

    @staticmethod
    def _cache_davs(dvc=None):
        """
        Cache the DAV into the dav cache (or create one) and return it.

        :param dvc: (mettle.lib.DavCache), target cache, if None a new one is created and returned.
        """
        if dvc is None:
            dvc = mettle.lib.DavCache()

        dvc.add_targ("site_id", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("usr_id", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("usr_id", mettle.lib.Dav(mettle.lib.Dav.eDavType.Max, 128))
        dvc.add_targ("auth_type", mettle.lib.Dav(mettle.lib.Dav.eDavType.Min, 1))
        dvc.add_targ("auth_type", mettle.lib.Dav(mettle.lib.Dav.eDavType.Max, 1))
        dvc.add_targ("auth_type", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("auth_type", mettle.lib.Dav(mettle.lib.Dav.eDavType.In, ['P','S','T']))
        dvc.add_targ("siteCode", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("authType", mettle.lib.Dav(mettle.lib.Dav.eDavType.Min, 1))
        dvc.add_targ("authType", mettle.lib.Dav(mettle.lib.Dav.eDavType.Max, 1))
        dvc.add_targ("authType", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("authData", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))

        return dvc

    def _get_davs(self, dvc=None):
        iUsrAuthByToken._cache_davs(dvc)

    def __repr__(self) -> str:
        return '<UsrAuth [site_code:%.32s, auth_type:%.32s, auth_data:%.32s]>' % (
            self.site_code, self.auth_type, self.auth_data)


    class List(list, mettle.io.ISerializable):
        """
        List Class
        """

        def _name(self) -> str:
            """
            Name of the list.

            :return: The name
            """
            return 'iUsrAuthByToken.List'

        def _serialize(self, _w: mettle.io.IWriter, _oname: str = None):
            """
            Serialize the list to a stream.

            :param _w:
            :param _oname:
            """
            if _oname == None:
                _oname = self._name()

            _w.write_start_list(_oname, len(self))

            for _rec in self:
                _rec._serialize(_w)

            _w.write_end(_oname)

        def _deserialize(self, _r: mettle.io.IReader, _oname: str = None):
            """
            Deserialize the list from a stream.

            :param _r:
            :param _oname:
            """
            if _oname == None:
                _oname = self._name()

            _cnt = _r.read_start_list(_oname)

            while _cnt >= 1:
                _rec  = iUsrAuthByToken()
                _cnt -= 1
                _rec._deserialize(_r)
                self.append(_rec)

            _r.read_end(_oname)

        def __repr__(self) -> str:
            return '<iUsrAuthByToken.List[%d]>' % (len(self))

        def _get_davs(self, dvc=None):
            return iUsrAuthByToken._cache_davs(dvc)

